Index: trunk/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 2528)
@@ -21,108 +21,24 @@
    !!            3.2  !  2009-02  (G. Madec, R. Benshila)  reintroduicing z*-coordinate
    !!             -   !  2009-06  (S. Masson, G. Madec)  TKE restart compatible with key_cpl
-   !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
-   !!   stp            : OPA system time-stepping
-   !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers variables
-   USE dom_oce         ! ocean space and time domain variables 
-   USE zdf_oce         ! ocean vertical physics variables
-   USE ldftra_oce      ! ocean tracer   - trends
-   USE ldfdyn_oce      ! ocean dynamics - trends
-   USE in_out_manager  ! I/O manager
-   USE iom             !
-   USE lbclnk
-
-   USE daymod          ! calendar                         (day     routine)
-
-   USE dtatem          ! ocean temperature data           (dta_tem routine)
-   USE dtasal          ! ocean salinity    data           (dta_sal routine)
-   USE sbcmod          ! surface boundary condition       (sbc     routine)
-   USE sbcrnf          ! surface boundary condition: runoff variables
-   USE sbccpl          ! surface boundary condition: coupled formulation (call send at end of step)
-   USE cpl_oasis3, ONLY : lk_cpl
-
+   !!            3.3  !  2010-05  (K. Mogensen, A. Weaver, M. Martin, D. Lea) Assimilation interface
+   !!             -   !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase + merge TRC-TRA
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   stp             : OPA system time-stepping
+   !!----------------------------------------------------------------------
+   USE step_oce         ! time stepping definition modules 
 #if defined key_top
-   USE trcstp          ! passive tracer time-stepping      (trc_stp routine)
-#endif
-
-   USE traqsr          ! solar radiation penetration      (tra_qsr routine)
-   USE trasbc          ! surface boundary condition       (tra_sbc routine)
-   USE trabbc          ! bottom boundary condition        (tra_bbc routine)
-   USE trabbl          ! bottom boundary layer            (tra_bbl routine)
-   USE tradmp          ! internal damping                 (tra_dmp routine)
-   USE traadv          ! advection scheme control     (tra_adv_ctl routine)
-   USE traldf          ! lateral mixing                   (tra_ldf routine)
-   USE cla             ! cross land advection             (tra_cla routine)
-   !   zdfkpp          ! KPP non-local tracer fluxes      (tra_kpp routine)
-   USE trazdf          ! vertical mixing                  (tra_zdf routine)
-   USE tranxt          ! time-stepping                    (tra_nxt routine)
-   USE tranpc          ! non-penetrative convection       (tra_npc routine)
-
-   USE eosbn2          ! equation of state                (eos_bn2 routine)
-
-   USE dynadv          ! advection                        (dyn_adv routine)
-   USE dynbfr          ! Bottom friction terms            (dyn_bfr routine)
-   USE dynvor          ! vorticity term                   (dyn_vor routine)
-   USE dynhpg          ! hydrostatic pressure grad.       (dyn_hpg routine)
-   USE dynldf          ! lateral momentum diffusion       (dyn_ldf routine)
-   USE dynzdf          ! vertical diffusion               (dyn_zdf routine)
-   USE dynspg_oce      ! surface pressure gradient        (dyn_spg routine)
-   USE dynspg          ! surface pressure gradient        (dyn_spg routine)
-   USE dynnxt          ! time-stepping                    (dyn_nxt routine)
-
-   USE obc_par         ! open boundary condition variables
-   USE obcdta          ! open boundary condition data     (obc_dta routine)
-   USE obcrst          ! open boundary cond. restart      (obc_rst routine)
-   USE obcrad          ! open boundary cond. radiation    (obc_rad routine)
-
-   USE bdy_par         ! unstructured open boundary data variables
-   USE bdydta          ! unstructured open boundary data  (bdy_dta routine)
-
-   USE sshwzv          ! vertical velocity and ssh        (ssh_wzv routine)
-
-   USE ldfslp          ! iso-neutral slopes               (ldf_slp routine)
-   USE ldfeiv          ! eddy induced velocity coef.      (ldf_eiv routine)
-
-   USE zdftmx          ! tide-induced vertical mixing     (zdf_tmx routine)
-   USE zdfbfr          ! bottom friction                  (zdf_bfr routine)
-   USE zdftke_old      ! old TKE vertical mixing      (zdf_tke_old routine)
-   USE zdftke          ! TKE vertical mixing              (zdf_tke routine)
-   USE zdfkpp          ! KPP vertical mixing              (zdf_kpp routine)
-   USE zdfddm          ! double diffusion mixing          (zdf_ddm routine)
-   USE zdfevd          ! enhanced vertical diffusion      (zdf_evd routine)
-   USE zdfric          ! Richardson vertical mixing       (zdf_ric routine)
-   USE zdfmxl          ! Mixed-layer depth                (zdf_mxl routine)
-
-   USE zpshde          ! partial step: hor. derivative     (zps_hde routine)
-
-   USE diawri          ! Standard run outputs             (dia_wri routine)
-   USE trdicp          ! Ocean momentum/tracers trends    (trd_wri routine)
-   USE trdmld          ! mixed-layer trends               (trd_mld routine)
-   USE trdmld_rst      ! restart for mixed-layer trends
-   USE trdmod_oce      ! ocean momentum/tracers trends
-   USE trdvor          ! vorticity budget                 (trd_vor routine)
-   USE diagap          ! hor. mean model-data gap         (dia_gap routine)
-   USE diahdy          ! dynamic height                   (dia_hdy routine)
-   USE diaptr          ! poleward transports              (dia_ptr routine)
-   USE diaar5          ! AR5 diagnosics                   (dia_ar5 routine)
-   USE diahth          ! thermocline depth                (dia_hth routine)
-   USE diafwb          ! freshwater budget                (dia_fwb routine)
-   USE flo_oce         ! floats variables
-   USE floats          ! floats computation               (flo_stp routine)
-
-   USE stpctl          ! time stepping control            (stp_ctl routine)
-   USE restart         ! ocean restart                    (rst_wri routine)
-   USE prtctl          ! Print control                    (prt_ctl routine)
-
+   USE trcstp           ! passive tracer time-stepping      (trc_stp routine)
+#endif
 #if defined key_agrif
    USE agrif_opa_sponge ! Momemtum and tracers sponges
 #endif
+   USE asminc           ! assimilation increments    (tra_asm_inc, dyn_asm_inc routines)
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   stp        ! called by opa.F90
+   PUBLIC   stp   ! called by opa.F90
 
    !! * Substitutions
@@ -130,9 +46,8 @@
 #  include "zdfddm_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -166,16 +81,12 @@
 #if defined key_agrif
       kstp = nit000 + Agrif_Nb_Step()
-!      IF( Agrif_Root() .and. lwp) Write(*,*) '---'
-!      IF(lwp) Write(*,*) 'Grid Number',Agrif_Fixed(),' time step ',kstp
 # if defined key_iomput
-      IF( Agrif_Nbstepint() == 0) CALL iom_swap
+      IF( Agrif_Nbstepint() == 0 )   CALL iom_swap
 # endif   
 #endif   
-      indic = 1                                       ! reset to no error condition
-
+                             indic = 0                ! reset to no error condition
       IF( kstp /= nit000 )   CALL day( kstp )         ! Calendar (day was already called at nit000 in day_init)
-
-      CALL iom_setkt( kstp )                          ! say to iom that we are at time step kstp
-      
+                             CALL iom_setkt( kstp )   ! say to iom that we are at time step kstp
+
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       ! Update data, open boundaries, surface boundary condition (including sea-ice)
@@ -186,5 +97,5 @@
       IF( lk_obc     )   CALL obc_dta( kstp )         ! update dynamic and tracer data at open boundaries
       IF( lk_obc     )   CALL obc_rad( kstp )         ! compute phase velocities at open boundaries
-      IF( lk_bdy     )   CALL bdy_dta( kstp )         ! update dynamic and tracer data at unstructured open boundary
+      IF( lk_bdy     )   CALL bdy_dta_frs( kstp )     ! update dynamic and tracer data for FRS conditions (BDY)
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -196,15 +107,16 @@
       ! Ocean physics update                (ua, va, ta, sa used as workspace)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-                         CALL bn2( tb, sb, rn2b )     ! before Brunt-Vaisala frequency
-                         CALL bn2( tn, sn, rn2  )     ! now    Brunt-Vaisala frequency
+                         CALL bn2( tsb, rn2b )        ! before Brunt-Vaisala frequency
+                         CALL bn2( tsn, rn2  )        ! now    Brunt-Vaisala frequency
       !
       !  VERTICAL PHYSICS   
                          CALL zdf_bfr( kstp )         ! bottom friction
+                         
       !                                               ! Vertical eddy viscosity and diffusivity coefficients
-      IF( lk_zdfric     )   CALL zdf_ric    ( kstp )  ! Richardson number dependent Kz
-      IF( lk_zdftke_old )   CALL zdf_tke_old( kstp )  ! TKE closure scheme for Kz (old scheme)
-      IF( lk_zdftke     )   CALL zdf_tke    ( kstp )  ! TKE closure scheme for Kz
-      IF( lk_zdfkpp     )   CALL zdf_kpp    ( kstp )  ! KPP closure scheme for Kz
-      IF( lk_zdfcst     )   THEN                      ! Constant Kz (reset avt, avm[uv] to the background value)
+      IF( lk_zdfric  )   CALL zdf_ric( kstp )            ! Richardson number dependent Kz
+      IF( lk_zdftke  )   CALL zdf_tke( kstp )            ! TKE closure scheme for Kz
+      IF( lk_zdfgls  )   CALL zdf_gls( kstp )            ! GLS closure scheme for Kz
+      IF( lk_zdfkpp  )   CALL zdf_kpp( kstp )            ! KPP closure scheme for Kz
+      IF( lk_zdfcst  )   THEN                            ! Constant Kz (reset avt, avm[uv] to the background value)
          avt (:,:,:) = rn_avt0 * tmask(:,:,:)
          avmu(:,:,:) = rn_avm0 * umask(:,:,:)
@@ -220,21 +132,26 @@
       IF( lk_zdfddm .AND. .NOT. lk_zdfkpp )   &
          &               CALL zdf_ddm( kstp )         ! double diffusive mixing
+         
                          CALL zdf_mxl( kstp )         ! mixed layer depth
 
-                                                      ! write tke information in the restart file
+                                                      ! write TKE or GLS information in the restart file
       IF( lrst_oce .AND. lk_zdftke )   CALL tke_rst( kstp, 'WRITE' )
+      IF( lrst_oce .AND. lk_zdfgls )   CALL gls_rst( kstp, 'WRITE' )
       !
       !  LATERAL  PHYSICS 
       !
       IF( lk_ldfslp ) THEN                            ! slope of lateral mixing
-                         CALL eos( tb, sb, rhd )                ! before in situ density
-         IF( ln_zps )    CALL zps_hde( kstp, tb, sb, rhd,  &    ! Partial steps: before horizontal gradient
-            &                              gtu, gsu, gru,  &    ! of t, s, rd at the last ocean level
-            &                              gtv, gsv, grv )
-                         CALL ldf_slp( kstp, rhd, rn2b )        ! before slope of the lateral mixing
+                         CALL eos( tsb, rhd )                ! before in situ density
+         IF( ln_zps )    CALL zps_hde( kstp, jpts, tsb, gtsu, gtsv,  &    ! Partial steps: before horizontal gradient
+            &                                      rhd, gru , grv  )      ! of t, s, rd at the last ocean level
+         IF( ln_traldf_grif ) THEN                           ! before slope for Griffies operator
+                         CALL ldf_slp_grif( kstp )
+         ELSE
+                         CALL ldf_slp( kstp, rhd, rn2b )     ! before slope for Madec operator
+         ENDIF
       ENDIF
 #if defined key_traldf_c2d
       IF( lk_traldf_eiv )   CALL ldf_eiv( kstp )      ! eddy induced velocity coefficient
-#  endif
+#endif
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -243,6 +160,4 @@
       IF( lk_floats  )   CALL flo_stp( kstp )         ! drifting Floats
       IF( lk_diahth  )   CALL dia_hth( kstp )         ! Thermocline depth (20 degres isotherm depth)
-      IF( lk_diagap  )   CALL dia_gap( kstp )         ! basin averaged diagnostics
-      IF( lk_diahdy  )   CALL dia_hdy( kstp )         ! dynamical heigh diagnostics
       IF( lk_diafwb  )   CALL dia_fwb( kstp )         ! Fresh water budget diagnostics
       IF( ln_diaptr  )   CALL dia_ptr( kstp )         ! Poleward TRansports diagnostics
@@ -260,38 +175,38 @@
       ! Active tracers                              (ua, va used as workspace)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-                             ta(:,:,:) = 0.e0               ! set tracer trends to zero
-                             sa(:,:,:) = 0.e0
-
+                             tsa(:,:,:,:) = 0.e0            ! set tracer trends to zero
+
+      IF(  ln_asmiau .AND. &
+         & ln_trainc     )   CALL tra_asm_inc( kstp )       ! apply tracer assimilation increment
                              CALL tra_sbc    ( kstp )       ! surface boundary condition
       IF( ln_traqsr      )   CALL tra_qsr    ( kstp )       ! penetrative solar radiation qsr
-      IF( lk_trabbc      )   CALL tra_bbc    ( kstp )       ! bottom heat flux
-      IF( lk_trabbl_dif  )   CALL tra_bbl_dif( kstp )       ! diffusive bottom boundary layer scheme
-      IF( lk_trabbl_adv  )   CALL tra_bbl_adv( kstp )       ! advective (and/or diffusive) bottom boundary layer scheme
+      IF( ln_trabbc      )   CALL tra_bbc    ( kstp )       ! bottom heat flux
+      IF( lk_trabbl      )   CALL tra_bbl    ( kstp )       ! advective (and/or diffusive) bottom boundary layer scheme
       IF( lk_tradmp      )   CALL tra_dmp    ( kstp )       ! internal damping trends
                              CALL tra_adv    ( kstp )       ! horizontal & vertical advection
-      IF( n_cla == 1     )   CALL tra_cla    ( kstp )       ! Cross Land Advection (Update Hor. advection)
-      IF( lk_zdfkpp )        CALL tra_kpp    ( kstp )       ! KPP non-local tracer fluxes
+      IF( lk_zdfkpp      )   CALL tra_kpp    ( kstp )       ! KPP non-local tracer fluxes
                              CALL tra_ldf    ( kstp )       ! lateral mixing
 #if defined key_agrif
+                             CALL tra_unswap
       IF(.NOT. Agrif_Root()) CALL Agrif_Sponge_tra          ! tracers sponge
+                             CALL tra_swap
 #endif
                              CALL tra_zdf    ( kstp )       ! vertical mixing and after tracer fields
 
       IF( ln_dynhpg_imp  ) THEN                             ! semi-implicit hpg (time stepping then eos)
-         IF( ln_zdfnpc   )   CALL tra_npc    ( kstp )            ! update after fields by non-penetrative convection
-                             CALL tra_nxt    ( kstp )            ! tracer fields at next time step
-                             CALL eos( ta, sa, rhd, rhop )       ! Time-filtered in situ density for hpg computation
-         IF( ln_zps      )   CALL zps_hde( kstp, ta, sa, rhd,   &   ! Partial steps: time filtered hor. derivative
-            &                                   gtu, gsu, gru,  &   ! of t, s, rd at the bottom ocean level
-            &                                   gtv, gsv, grv )
+         IF( ln_zdfnpc   )   CALL tra_npc( kstp )                ! update after fields by non-penetrative convection
+                             CALL tra_nxt( kstp )                ! tracer fields at next time step
+                             CALL eos    ( tsa, rhd, rhop )      ! Time-filtered in situ density for hpg computation
+         IF( ln_zps      )   CALL zps_hde( kstp, jpts, tsa, gtsu, gtsv,  &    ! zps: time filtered hor. derivative
+            &                                          rhd, gru , grv  )      ! of t, s, rd at the last ocean level
          
       ELSE                                                  ! centered hpg  (eos then time stepping)
-                             CALL eos( tn, sn, rhd, rhop )       ! now in situ density for hpg computation
-         IF( ln_zps      )   CALL zps_hde( kstp, tn, sn, rhd,   &   ! Partial steps: now horizontal derivative
-            &                                   gtu, gsu, gru,  &   ! of t, s, rd at the bottom ocean level
-            &                                   gtv, gsv, grv )
-         IF( ln_zdfnpc   )   CALL tra_npc    ( kstp )       ! update after fields by non-penetrative convection
-                             CALL tra_nxt    ( kstp )       ! tracer fields at next time step
+                             CALL eos    ( tsn, rhd, rhop )      ! now in situ density for hpg computation
+         IF( ln_zps      )   CALL zps_hde( kstp, jpts, tsn, gtsu, gtsv,  &    ! zps: now hor. derivative
+            &                                          rhd, gru , grv  )      ! of t, s, rd at the last ocean level
+         IF( ln_zdfnpc   )   CALL tra_npc( kstp )                ! update after fields by non-penetrative convection
+                             CALL tra_nxt( kstp )                ! tracer fields at next time step
       ENDIF 
+                             CALL tra_unswap                ! udate T & S 3D arrays  (to be suppressed)
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -301,4 +216,6 @@
                                va(:,:,:) = 0.e0
 
+      IF(  ln_asmiau .AND. &
+         & ln_dyninc       )   CALL dyn_asm_inc( kstp )     ! apply dynamics assimilation increment
                                CALL dyn_adv( kstp )         ! advection (vector or flux form)
                                CALL dyn_vor( kstp )         ! vorticity term including Coriolis
@@ -308,11 +225,13 @@
 #endif
                                CALL dyn_hpg( kstp )         ! horizontal gradient of Hydrostatic pressure
-                               CALL dyn_bfr( kstp )           ! bottom friction   
+                               CALL dyn_bfr( kstp )         ! bottom friction   
                                CALL dyn_zdf( kstp )         ! vertical diffusion
-                               indic=0
                                CALL dyn_spg( kstp, indic )  ! surface pressure gradient
                                CALL dyn_nxt( kstp )         ! lateral velocity at next time step
 
                                CALL ssh_nxt( kstp )         ! sea surface height at next time step
+
+      IF( ln_diahsb        )   CALL dia_hsb( kstp )         ! - ML - global conservation diagnostics
+      IF( lk_diaobs  )         CALL dia_obs( kstp )         ! obs-minus-model (assimilation) diagnostics (call after dynamics update)
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Index: trunk/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 2528)
@@ -0,0 +1,106 @@
+MODULE step_oce
+   !!======================================================================
+   !!                       ***  MODULE step_oce  ***
+   !! Ocean time-stepping : module used in both initialisation phase and time stepping
+   !!======================================================================
+   !! History :   3.3  ! 2010-08  (C. Ethe)  Original code - reorganisation of the initial phase
+   !!----------------------------------------------------------------------
+   USE oce              ! ocean dynamics and tracers variables
+   USE dom_oce          ! ocean space and time domain variables 
+   USE zdf_oce          ! ocean vertical physics variables
+   USE ldftra_oce       ! ocean tracer   - trends
+   USE ldfdyn_oce       ! ocean dynamics - trends
+   USE in_out_manager   ! I/O manager
+   USE iom              !
+   USE lbclnk
+
+   USE daymod           ! calendar                         (day     routine)
+
+   USE dtatem           ! ocean temperature data           (dta_tem routine)
+   USE dtasal           ! ocean salinity    data           (dta_sal routine)
+   USE sbcmod           ! surface boundary condition       (sbc     routine)
+   USE sbcrnf           ! surface boundary condition: runoff variables
+   USE sbccpl           ! surface boundary condition: coupled formulation (call send at end of step)
+   USE cpl_oasis3, ONLY : lk_cpl
+
+   USE traqsr           ! solar radiation penetration      (tra_qsr routine)
+   USE trasbc           ! surface boundary condition       (tra_sbc routine)
+   USE trabbc           ! bottom boundary condition        (tra_bbc routine)
+   USE trabbl           ! bottom boundary layer            (tra_bbl routine)
+   USE tradmp           ! internal damping                 (tra_dmp routine)
+   USE traadv           ! advection scheme control     (tra_adv_ctl routine)
+   USE traldf           ! lateral mixing                   (tra_ldf routine)
+   !   zdfkpp           ! KPP non-local tracer fluxes      (tra_kpp routine)
+   USE trazdf           ! vertical mixing                  (tra_zdf routine)
+   USE tranxt           ! time-stepping                    (tra_nxt routine)
+   USE tranpc           ! non-penetrative convection       (tra_npc routine)
+
+   USE eosbn2           ! equation of state                (eos_bn2 routine)
+
+   USE dynadv           ! advection                        (dyn_adv routine)
+   USE dynbfr           ! Bottom friction terms            (dyn_bfr routine)
+   USE dynvor           ! vorticity term                   (dyn_vor routine)
+   USE dynhpg           ! hydrostatic pressure grad.       (dyn_hpg routine)
+   USE dynldf           ! lateral momentum diffusion       (dyn_ldf routine)
+   USE dynzdf           ! vertical diffusion               (dyn_zdf routine)
+   USE dynspg_oce       ! surface pressure gradient        (dyn_spg routine)
+   USE dynspg           ! surface pressure gradient        (dyn_spg routine)
+   USE dynnxt           ! time-stepping                    (dyn_nxt routine)
+
+   USE obc_par          ! open boundary condition variables
+   USE obcdta           ! open boundary condition data     (obc_dta routine)
+   USE obcrst           ! open boundary cond. restart      (obc_rst routine)
+   USE obcrad           ! open boundary cond. radiation    (obc_rad routine)
+
+   USE bdy_par          ! unstructured open boundary data variables
+   USE bdydta           ! unstructured open boundary data  (bdy_dta routine)
+
+   USE sshwzv           ! vertical velocity and ssh        (ssh_wzv routine)
+
+   USE ldfslp           ! iso-neutral slopes               (ldf_slp routine)
+   USE ldfeiv           ! eddy induced velocity coef.      (ldf_eiv routine)
+
+   USE zdftmx           ! tide-induced vertical mixing     (zdf_tmx routine)
+   USE zdfbfr           ! bottom friction                  (zdf_bfr routine)
+   USE zdftke           ! TKE vertical mixing              (zdf_tke routine)
+   USE zdfgls           ! GLS vertical mixing              (zdf_gls routine)
+   USE zdfkpp           ! KPP vertical mixing              (zdf_kpp routine)
+   USE zdfddm           ! double diffusion mixing          (zdf_ddm routine)
+   USE zdfevd           ! enhanced vertical diffusion      (zdf_evd routine)
+   USE zdfric           ! Richardson vertical mixing       (zdf_ric routine)
+   USE zdfmxl           ! Mixed-layer depth                (zdf_mxl routine)
+
+   USE zpshde           ! partial step: hor. derivative     (zps_hde routine)
+
+   USE diawri           ! Standard run outputs             (dia_wri routine)
+   USE trdicp           ! Ocean momentum/tracers trends    (trd_wri routine)
+   USE trdmld           ! mixed-layer trends               (trd_mld routine)
+   USE trdmld_rst       ! restart for mixed-layer trends
+   USE trdmod_oce       ! ocean momentum/tracers trends
+   USE trdmod           ! momentum/tracers trends   
+   USE trdvor           ! vorticity budget                 (trd_vor routine)
+   USE diaptr           ! poleward transports              (dia_ptr routine)
+   USE diaar5           ! AR5 diagnosics                   (dia_ar5 routine)
+   USE diahth           ! thermocline depth                (dia_hth routine)
+   USE diafwb           ! freshwater budget                (dia_fwb routine)
+   USE diahsb           ! heat, salt and volume budgets    (dia_hsb routine)
+   USE flo_oce          ! floats variables
+   USE floats           ! floats computation               (flo_stp routine)
+
+   USE stpctl           ! time stepping control            (stp_ctl routine)
+   USE restart          ! ocean restart                    (rst_wri routine)
+   USE prtctl           ! Print control                    (prt_ctl routine)
+
+   USE traswp           ! Swap arrays           (tra_swp, tra_unswp routine)
+
+   USE diaobs           ! Observation operator
+
+#if defined key_agrif
+   USE agrif_opa_sponge ! Momemtum and tracers sponges
+#endif
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!======================================================================
+END MODULE step_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/stpctl.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/stpctl.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/stpctl.F90	(revision 2528)
@@ -21,4 +21,5 @@
    USE lib_mpp         ! distributed memory computing
    USE dynspg_oce      ! pressure gradient schemes 
+   USE c1d             ! 1D vertical configuration
 
    IMPLICIT NONE
@@ -27,7 +28,7 @@
    PUBLIC stp_ctl           ! routine called by step.F90
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -139,4 +140,7 @@
 9500  FORMAT (' kt=',i6,' min SSS: ',1pg11.4,', i j: ',2i5)
 
+      
+      IF( lk_c1d )  RETURN          ! No log file in case of 1D vertical configuration
+
       ! log file (solver or ssh statistics)
       ! --------
Index: trunk/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 2528)
@@ -20,5 +20,6 @@
    PUBLIC   trc_oce_rgb_read   ! routine called by traqsr.F90
    PUBLIC   trc_oce_ext_lev    ! function called by traqsr.F90 at least
-   
+ 
+   REAL(wp), PUBLIC                          ::   r_si2   !: largest depth of extinction (blue & 0.01 mg.m-3)  (RGB)
    REAL(wp), PUBLIC , DIMENSION(jpi,jpj,jpk) ::   etot3   !: light absortion coefficient
 
@@ -35,10 +36,22 @@
 #endif
 
+#if defined key_offline
+   !!----------------------------------------------------------------------
+   !!   'key_offline'                                     OFFLINE mode          
+   !!----------------------------------------------------------------------
+   LOGICAL, PUBLIC, PARAMETER ::   lk_offline = .TRUE.   !: offline flag
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option                                   NO  OFFLINE mode          
+   !!----------------------------------------------------------------------
+   LOGICAL, PUBLIC, PARAMETER ::   lk_offline = .FALSE.   !: offline flag
+#endif
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -138,4 +151,7 @@
       prgb(:,:) = zrgb(2:4,:)
       !
+      r_si2 = 1.e0 / zrgb(2, 1)        ! blue with the smallest chlorophyll concentration)
+      IF(lwp) WRITE(numout,*) '      RGB longest depth of extinction    r_si2 = ', r_si2
+      !
       DO jc = 1, 61                         ! check
          zchl = zrgb(1,jc)
@@ -164,14 +180,9 @@
       REAL(wp), DIMENSION(3,61), INTENT(out) ::   prgb   ! tabulated attenuation coefficient
       !!
-      INTEGER  ::   jchl, jband   ! dummy loop indices
+      INTEGER  ::   jc, jb ! dummy loop indice
+      INTEGER  ::   irgb   ! temporary integer
+      REAL(wp) ::   zchl   ! temporary scalar
       INTEGER  ::   numlight
-      REAL(wp) ::   zchl
-      !!----------------------------------------------------------------------
-      !
-      CALL ctl_opn( numlight, 'kRGB61.txt', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp )
-      DO jchl = 1, 61
-         READ(numlight,*) zchl, ( prgb(jband,jchl), jband=1,3 )
-      END DO
-      CLOSE( numlight )
+      !!----------------------------------------------------------------------
       !
       IF(lwp) THEN                         ! control print
@@ -179,5 +190,21 @@
          WRITE(numout,*) ' trc_oce_rgb_read : optical look-up table read in kRGB61.txt file'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~'
+         WRITE(numout,*) 
       ENDIF
+      !
+      CALL ctl_opn( numlight, 'kRGB61.txt', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp )
+      DO jc = 1, 61
+         READ(numlight,*) zchl, ( prgb(jb,jc), jb = 1, 3 )
+         irgb = NINT( 41 + 20.* LOG10( zchl ) + 1.e-15 )   
+         IF(lwp) WRITE(numout,*) '    jc =', jc, '  Chl = ', zchl, '  irgb = ', irgb  
+         IF( irgb /= jc ) THEN  
+            IF(lwp) WRITE(numout,*) '    jc =', jc, '  Chl = ', zchl, '  Chl class = ', irgb
+            CALL ctl_stop( 'trc_oce_rgb_read : inconsistency in Chl tabulated attenuation coeff.' )
+         ENDIF
+      END DO
+      CLOSE( numlight )
+      !
+      r_si2 = 1.e0 / prgb(1, 1)      ! blue with the smallest chlorophyll concentration)
+      IF(lwp) WRITE(numout,*) '      RGB longest depth of extinction    r_si2 = ', r_si2
       !
    END SUBROUTINE trc_oce_rgb_read
